#!/usr/bin/perl

require File::Glob;
use File::Basename;
use File::Copy;
use File::Path qw( make_path );
use Cwd;

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!!!!!!!!! Most Important Variables !!!!!!!!!!!!!

# Change to match media types m4v, mkv, mpeg, etc
@files = glob("*.m4v *.mkv");

# This is the base directory they will be moved to.
# No ending slash
$target_directory = "/Volumes/250INT";

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

##########################################
### Read contents of this script to    ###
### indicate on screen where variables ###
### are and how to change              ###
##########################################
$script_name = $0;
if (-e $script_name) {
	open (SCRIPT, $script_name);
	@buffer = <SCRIPT>;
	close (SCRIPT);
}

$counter = 0;
system ("clear");

################################################
### Find variables within script and display ###
### to screen their position and value       ###
################################################

foreach (@buffer) {
	if ($_ =~ /\$target_directory \=/ ) {
		print ("Target Directory is: $target_directory\n");
		print ("Folder can be adjusted by changing line $counter in $script_name\n\n");
	}
	if ($_ =~ /^\@files = glob/) {
		if ($_ =~ /"(.+)"/) {
			@extensions = split(' ',$_);
			print ("\n\n\n\n\nMoving File(s) With Following Extensions: ");
			foreach (@extensions) {
				if ($_ =~ /\*\.(\w+)/ ) {
					print ("$1 ");
				}
			}
			print ("\n");
			print ("Matches can be adjusted by changing line $counter in $script_name\n\n");

		}
	}
	$counter++;
}
print ("Press Enter to Continue\n");
$input = <>;
system("clear");
print ("\n\n\n");
undef @buffer;

#############################################################
### Go through each file found and breakout the Title and ###
### Season information from the file name                 ###
#############################################################
foreach (@files) {
	undef $name;
	$media_toggle = 0;
	########################################################
	### Search for pattern of s1e2 (case doesn't matter) ###
	### Will skip file if it doesn't have this patern    ###
	########################################################
	if ($_ =~ /s(\d+)e(\d+)/i) {
		@buffer = split('\.',$_);
		$counter = -1;
		$name_toggle = 0;
		foreach (@buffer) {
				if ( $_ =~ /s(\d+)e(\d+)/i ) {
					$season = $1;
					$episode = $2;
					$name_toggle = $counter;
					$media_toggle = 1;
					####################################################
					### Take care of Name Spacing and Casing         ### 
					### Works by splitting on "." (periods) in title ###
					### and then combing all elements before the     ###
					### s1e2 pattern.								 ###
					####################################################
					for ($counter_name = 0; $counter_name <= $name_toggle; $counter_name++) {
						$line = $buffer[$counter_name];
						$line =~ s/([a-z])([A-Z])/$1 $2/g;
						$temp_name = join '', map { ucfirst lc } split /(\s+)|(-)|(_)/, $line;
						$temp_name =~ s/([a-z])_([0-9A-Z])/$1 $2/g;
						$name .= $temp_name;
						$name =~ s/(?<=[a-z])(?=[A-Z0-9])|(?<=[0-9])(?=[A-Z])/ /g;
					}
				}
			$counter++;
			}
					
	}
############################################################
### If a file matched the search pattern, now mcopy to   ###
### the destination. If the copy was successfull, delete ###
### original file.                                       ###
############################################################
if ($media_toggle == 1) {
$full_path = "$target_directory/$name/Season $season/";
$full_path =~ s/\\/\//g;
$full_name = "${full_path}${_}";
make_path $full_path; 
print ("Moving $_ --> $full_path\n");
&move_file;

}	
}

sub move_file {
	### Move is faster, copy then delete might be safer
	move($_,$full_name)or die "Copy failed: $!";
	#copy($_,$full_name)or die "Copy failed: $!";
	#if (-e $full_name) {
	#	unlink $_;
	#}else{
	#	print ("  !!! Could not copy $_ to $full_path\n");
	#}

}
__END__

